/**@file
 *@brief	cannaץȥ򤷤٤ؿ
 *@date		Fri,23 Aug,2013 - Mon,09 Sep,2013
 *@date		Sun,22 Sep,2013
 *@date		Mon,30 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef cannaprotocol_low_h_included_
#define cannaprotocol_low_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#include "cannaprotocol_common.h"



#ifdef __cplusplus
extern "C" {
#endif



extern bool cannaprotocol_Initialize(struct canna_protocol_transaction_t* const cpt, const string8_t user[]); /* 01 */
extern bool cannaprotocol_Finalize(struct canna_protocol_transaction_t* const cpt); /* 02 */

extern bool cannaprotocol_CreateContext(struct canna_protocol_context_transaction_t* const cpct); /* 03 */
extern bool cannaprotocol_CloseContext(struct canna_protocol_context_transaction_t* const cpct); /* 05 */
extern bool cannaprotocol_GetDictionaryList(struct canna_protocol_context_transaction_t* const cpct); /* 06 */
extern bool cannaprotocol_MountDictionary(struct canna_protocol_context_transaction_t* const cpct, const string8_t dic_name[]); /* 08 */
extern bool cannaprotocol_BeginConvert(struct canna_protocol_context_transaction_t* const cpct, const string16_t yomi[], int_fast16_t len_yomi, string16_t* const converted_str, size_t maxlen_converted_str, int_fast16_t* const num_phrase); /* 0F */
extern bool cannaprotocol_EndConvert(struct canna_protocol_context_transaction_t* const cpct, bool learn, int_fast16_t num_phrase, const int_fast16_t selected_phrase[]); /* 10 */
extern bool cannaprotocol_GetCandidacyList(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t cur_phrase, int_fast16_t* const num_candidacy, string16_t* const candidacy_list, size_t maxlen_candidacy_list, size_t* const len_candidacy_list); /* 11 */
extern bool cannaprotocol_GetYomi(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t cur_phrase, string16_t* const yomi_str, size_t maxlen_yomi_str, int_fast16_t* const len_yomi); /* 12 */
extern bool cannaprotocol_ResizePause(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t phrase, int_fast16_t new_len, string16_t* const converted_str, size_t maxlen_converted_str, int_fast16_t* const num_phrase); /* 1A */
extern bool cannaprotocol_GetHinshi(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t cur_phrase, int_fast16_t cur_candidacy, int_fast16_t* const len_hinshi, string16_t* const hinshi, size_t maxlen_hinshi); /* 1B */
extern bool cannaprotocol_SetLocale(struct canna_protocol_transaction_t* const cpt, const string8_t locale[]); /* 1E */
extern bool cannaprotocol_NoticeGroupName(struct canna_protocol_transaction_t* const cpt, const string8_t groupname[]); /* 22 */



#ifdef __cplusplus
}
#endif

#endif /* cannaprotocol_low_h_included_ */
/* [ End of File ] */
