/**@file
 *@brief	cannaץȥ򤷤٤ؿ顧Ѵ
 *@date		Fri,30 Aug,2013 - Sun,22 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_ERRNO_H)
# include <errno.h>
#endif
#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h> /* for OpenBSD, netinet/in.h must faster than arpa/inet.h */
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif

#include "intl.h"
#include "logger.h"
#include "type_punned_cast.h"
#include "cannaprotocol_common.h"
#include "cannaprotocol_low_sub.h"
#include "cannaprotocol_low.h"



/** ʥץȥ롧Ѵ
 *@param[in,out]	cpct					̿Ѿ
 *@param[in]		yomi				Ѵɤߤ
 *@param			len_yomi			yomiʸĹ
 *@param[out]		converted_str		Ѵ̡NULL: Ѵ̤ɤ߹ޤʤ
 *@param			maxlen_converted_str	converted_str ˳ǼǤʸĹ
 *@param[out]		num_phrase			Ѵ̤ʸ
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Fri,30 Aug,2013 - Sun,01 Sep,2013
 *@date		Fri,06 Sep,2013
 */
bool cannaprotocol_BeginConvert(struct canna_protocol_context_transaction_t* const cpct, const string16_t yomi[], int_fast16_t len_yomi, string16_t* const converted_str, size_t maxlen_converted_str, int_fast16_t* const num_phrase)
{
	assert (NULL != cpct);
	assert (NULL != yomi);
	assert (NULL != converted_str);
	assert (NULL != num_phrase);


	{	/*  */
		void* ptr_write = cpct->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = CannaProtocol_BeginConvert;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = UINT8_C(0x00);
		const int_fast16_t len_data = (4 + 2 + (len_yomi + 1) * 2);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons((uint16_t)len_data);
		const int32_t mode_convert = ((CP_RK_XFER << CP_RK_XFERBITS) | CP_RK_KFER);		/* ʡҤ餬ʡν֡ */
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s32p ++ = (int32_t)htonl((uint32_t)mode_convert);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cpct->context);
		memcpy(ptr_write, yomi, (sizeof(yomi[0]) * (size_t)(len_yomi + 1)));
		const size_t len_write = (4 + (size_t)len_data);
		assert (len_write <= number_(cpct->buf.w));
		ssize_t ret_write = write(cpct->cpt->sock, cpct->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_BeginConvert()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_BeginConvert()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = cannaprotocol_check_result(cpct->cpt, CannaProtocol_BeginConvert, cpct->buf.r, (uint_fast16_t)number_(cpct->buf.r));
		void* ptr_read = &(cpct->buf.r[4]);
		if (len_read < 8) {
			LOGGER_ERR(l,N_("The reply size of the server is mismatch at %1$s %2$zd"), "cannaprotocol_BeginConvert()", len_read);
			return false;
		}
		const int_fast16_t dat_num = (int_fast16_t)ntohs(*((union type_punned_pointer_cast_t* const)&ptr_read)->u16p ++);
		if (-1 == dat_num) {
			LOGGER_ERR(l,N_("Convert failed at %1$s"), "cannaprotocol_BeginConvert()");
			return false;
		}
		(*num_phrase) = dat_num;
		if (NULL != converted_str) {
			const size_t len_converted_str = (size_t)(len_read - 6);
			if (maxlen_converted_str < len_converted_str) {
				LOGGER_ERR(l,N_("Buffer overflow at %1$s"), "cannaprotocol_BeginConvert()");
				return false;
			}
			memcpy(converted_str, ptr_read, (sizeof(converted_str[0]) * len_converted_str));
		}
	}
	return true;
}



/** ʥץȥ롧Ѵλ
 *@param[in,out]	cpct					̿Ѿ
 *@param			learn				ؽԤݤ
 *@param			num_phrase			ꤷʸ
 *@param[in]		selected_phrase		Ѥֹ
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Fri,30 Aug,2013 - Sat,31 Aug,2013
 */
bool cannaprotocol_EndConvert(struct canna_protocol_context_transaction_t* const cpct, bool learn, int_fast16_t num_phrase, const int_fast16_t selected_phrase[])
{
	assert (NULL != cpct);
	assert (0 <= num_phrase);
	assert (NULL != selected_phrase);


	{	/*  */
		void* ptr_write = cpct->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = CannaProtocol_EndConvert;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = UINT8_C(0x00);
		const size_t len_data = (2 + 2 + 4 + (size_t)num_phrase * 2);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons((uint16_t)len_data);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cpct->context);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)num_phrase);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s32p ++ = (int32_t)htonl((uint32_t)(learn ? CP_LEARN_ON : CP_LEARN_OFF));
		for (uint_fast16_t i = 0; i < (uint_fast16_t)num_phrase; ++i) {
			*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)selected_phrase[i]);
		}
		const size_t len_write = (4 + len_data);
		assert (len_write <= number_(cpct->buf.w));
		ssize_t ret_write = write(cpct->cpt->sock, cpct->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_EndConvert()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_EndConvert()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = cannaprotocol_check_result(cpct->cpt, CannaProtocol_EndConvert, cpct->buf.r, (uint_fast16_t)number_(cpct->buf.r));
		void* ptr_read = &(cpct->buf.r[4]);
		if (5 != len_read) {
			LOGGER_ERR(l,N_("The reply size of the server is mismatch at %1$s %2$zd"), "cannaprotocol_EndConvert()", len_read);
			return false;
		}
		const int_fast8_t dat_stat = *((union type_punned_pointer_cast_t* const)&ptr_read)->s8p ++;
		switch (dat_stat) {
		case 0:
			break;
		case -1:
			LOGGER_ERR(l,N_("Failed at %1$s."), "cannaprotocol_EndConvert()");
			return false;
		default:
			LOGGER_ERR(l,N_("The reply of the server is unknown at %1$s: buf[4] = %2$"PRId8""), "cannaprotocol_EndConvert()", (int8_t)dat_stat);
			return false;
		}
	}
	return true;
}

/* [ End of File ] */
