/**@file
 *@brief	cannaץȥ򤷤٤ؿ顧Ϣ
 *@date		Fri,23 Aug,2013 - Sun,22 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_ERRNO_H)
# include <errno.h>
#endif
#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h> /* for OpenBSD, netinet/in.h must faster than arpa/inet.h */
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif
#if defined(HAVE_SYS_TYPES_H)
# include <sys/types.h>
#endif
#if defined(HAVE_SYS_UIO_H)
# include <sys/uio.h>
#endif
#if defined(HAVE_UNISTD_H)
# include <unistd.h>
#endif

#include "intl.h"
#include "logger.h"
#include "type_punned_cast.h"
#include "cannaprotocol_common.h"
#include "cannaprotocol_low_sub.h"
#include "cannaprotocol_low.h"



/** ʥץȥ롧
 *@param[in,out]	cpt					̿Ѿ
 *@param[in]		user				桼̾
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Sat,24 Aug,2013
 *@date		Mon,09 Sep,2013
 */
bool cannaprotocol_Initialize(struct canna_protocol_transaction_t* const cpt, const string8_t user[])
{
	assert (NULL != cpt);
	assert (NULL != user);


	string8lcpy(cpt->user, user, (uint_fast16_t)number_(cpt->user));

	{	/*  */
		size_t len_write;
		const size_t len_version = string8len(cpt->cannaprotocol_version);
		const size_t len_user = string8len(cpt->user);
		const size_t len_data = len_version + len_user + 1;
		void* ptr_write = cpt->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s32p ++ = (int32_t)htonl(CannaProtocol_Initialize);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s32p ++ = (int32_t)htonl((uint32_t)len_data);
		string8lcpy(((union type_punned_pointer_cast_t* const)&ptr_write)->u8p, cpt->cannaprotocol_version, (uint_fast16_t)(number_(cpt->buf.w) - len_data));
		((union type_punned_pointer_cast_t* const)&ptr_write)->u8p += len_version;
		string8lcpy(((union type_punned_pointer_cast_t* const)&ptr_write)->u8p, cpt->user, (uint_fast16_t)(number_(cpt->buf.w) - len_data));
		((union type_punned_pointer_cast_t* const)&ptr_write)->u8p += len_user;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = '\0';
		len_write = 8 + len_data;
		assert (len_write <= number_(cpt->buf.w));
		const ssize_t ret_write = write(cpt->sock, cpt->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_Initialize()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_Initialize()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = read(cpt->sock, cpt->buf.r, number_(cpt->buf.r));
		void* ptr_read = cpt->buf.r;
		if (-1 == len_read) {
			LOGGER_ERR(l,N_("read() failed at %1$s. %2$s"), "cannaprotocol_Initialize()", strerror(errno));
			return false;
		}
		if (4 != len_read) {
			LOGGER_ERR(l,N_("Not supported yet at %1$s, read() return %2$zd"), "cannaprotocol_Initialize()", len_read);
			return false;
		}
		const int_fast32_t dat_stat = (int_fast32_t)ntohl(*((union type_punned_pointer_cast_t* const)&ptr_read)->u32p);
		if (-1 == dat_stat) {
			LOGGER_ERR(l,N_("Server error at %1$s"), "cannaprotocol_Initialize()");
			return false;
		}
		const uint_fast16_t dat_server_minor_version = ntohs(*((union type_punned_pointer_cast_t* const)&ptr_read)->u16p ++);
		cpt->server_minor_version = dat_server_minor_version;
		const int_fast16_t dat_context = (int_fast16_t)htons(*((union type_punned_pointer_cast_t* const)&ptr_read)->u16p ++);
		cpt->initial_context = dat_context;
	}
	return true;
}



/** ʥץȥ롧λ
 *@param[in,out]	cpt					̿Ѿ
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Sat,24 Aug,2013
 *@date		Mon,09 Sep,2013
 */
bool cannaprotocol_Finalize(struct canna_protocol_transaction_t* const cpt)
{
	assert (NULL != cpt);

	{	/*  */
		size_t len_write;
		void* ptr_write = cpt->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = CannaProtocol_Finalize;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = UINT8_C(0x00);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons(0);
		len_write = 4;
		assert (len_write <= number_(cpt->buf.w));
		ssize_t ret_write = write(cpt->sock, cpt->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_Finalize()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_Finalize()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = cannaprotocol_check_result(cpt, CannaProtocol_Finalize, cpt->buf.r, (uint_fast16_t)number_(cpt->buf.r));
		void* ptr_read = &(cpt->buf.r[4]);
		if (5 != len_read) {
			LOGGER_ERR(l,N_("The reply size of the server is mismatch at %1$s %2$zd"), "cannaprotocol_Finalize()", len_read);
			return false;
		}
		const int_fast8_t dat_stat = *((union type_punned_pointer_cast_t* const)&ptr_read)->s8p ++;
		switch (dat_stat) {
		case 0:
			break;
		case -1:
			LOGGER_ERR(l,N_("Failed at %1$s."), "cannaprotocol_Finalize()");
			return false;
		default:
			LOGGER_ERR(l,N_("The reply of the server is unknown at %1$s: buf[4] = %2$"PRId8""), "cannaprotocol_Finalize()", (int8_t)dat_stat);
			return false;
		}
	}
	return true;
}

/* [ End of File ] */
