/**@file
 *@brief	cannaץȥ򤷤٤ؿ顧ʬ
 *@date		Fri,23 Aug,2013 - Wed,04 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef cannaprotocol_low_sub_h_included_
#define cannaprotocol_low_sub_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_LIMITS_H)
# include <limits.h>
#endif
#if (CHAR_BIT != 8)
# error "This program requires that char bit is 8."
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#include "cannaprotocol_common.h"



#ifdef __cplusplus
extern "C" {
#endif



#define CP_RK_XFERBITS  4       /**< BeginConvert ǻꤹ⡼ɡRK_?FER Υӥåȥեɤ */
#define CP_RK_XFER      1       /**< BeginConvert ǻꤹ⡼ɡҤ餬Ѵ */
#define CP_RK_HFER      2       /**< BeginConvert ǻꤹ⡼ɡȾʸѴ */
#define CP_RK_KFER      3       /**< BeginConvert ǻꤹ⡼ɡѴ */
#define CP_RK_ZFER      4       /**< BeginConvert ǻꤹ⡼ɡʸѴ */

#define CP_LEARN_OFF    0       /**< EndConvert ǻꤹ⡼ɡؽԤʤ */
#define CP_LEARN_ON     1       /**< EndConvert ǻꤹ⡼ɡؽԤ */

/** ץȥ׵ֹ */
enum canna_protocol_major_code_t {
	CannaProtocol_Initialize             = 0x01, /**<  */
	CannaProtocol_Finalize               = 0x02, /**< λ */
	CannaProtocol_CreateContext          = 0x03, /**< ƥȺ */
	CannaProtocol_DuplicateContext       = 0x04, /**< ƥʣ */
	CannaProtocol_CloseContext           = 0x05, /**< ƥȺ */
	CannaProtocol_GetDictionaryList      = 0x06, /**< ơ֥ */
	CannaProtocol_GetDirectoryList       = 0x07, /**< ǥ쥯ȥ */
	CannaProtocol_MountDictionary        = 0x08, /**< ꥹɲ */
	CannaProtocol_UnmountDictionary      = 0x09, /**< ꥹȺ */
	CannaProtocol_RemountDictionary      = 0x0A, /**< ꥹѹ */
	CannaProtocol_GetMountDictionaryList = 0x0B, /**< ꥹȰ */
	CannaProtocol_QueryDictionary        = 0x0C, /**< Ͽǽ䤤碌 */
	CannaProtocol_DefineWord             = 0x0D, /**< ñϿ */
	CannaProtocol_DeleteWord             = 0x0E, /**< ñ */
	CannaProtocol_BeginConvert           = 0x0F, /**< Ѵ */
	CannaProtocol_EndConvert             = 0x10, /**< Ѵλ */
	CannaProtocol_GetCandidacyList       = 0x11, /**<  */
	CannaProtocol_GetYomi                = 0x12, /**< ɤߤʼ */
	CannaProtocol_SubstYomi              = 0x13, /**< ưѴ */
	CannaProtocol_StoreYomi              = 0x14, /**< ɤߤѹ */
	CannaProtocol_StoreRange             = 0x15, /**< ʸΤߤκѴ */
	CannaProtocol_GetLastYomi            = 0x16, /**< ̤ʸɤ߼ */
	CannaProtocol_FlushYomi              = 0x17, /**< Ѵ */
	CannaProtocol_RemoveYomi             = 0x18, /**< ɤߥХåե */
	CannaProtocol_GetSimpleKanji         = 0x19, /**< μФ */
	CannaProtocol_ResizePause            = 0x1A, /**< ڤѹ */
	CannaProtocol_GetHinshi              = 0x1B, /**< ʻ */
	CannaProtocol_GetLex                 = 0x1C, /**< Ǿ */
	CannaProtocol_GetStatus              = 0x1D, /**< Ͼ */
	CannaProtocol_SetLocale              = 0x1E, /**< locale󥻥å */
	CannaProtocol_AutoConvert            = 0x1F, /**< ưѴ */
	CannaProtocol_QueryExtensions        = 0x20, /**< ĥץȥ䤤碌 */
	CannaProtocol_SetApplicationName     = 0x21, /**< ץꥱ̾Ͽ */
	CannaProtocol_NoticeGroupName        = 0x22, /**< 롼̾ */
	CannaProtocol_KillServer             = 0x24, /**< Фλ */
};



extern ssize_t cannaprotocol_check_result(struct canna_protocol_transaction_t* const cpt, uint_fast8_t arg_code, void* ptr, uint_fast16_t buf_size);




#ifdef __cplusplus
}
#endif

#endif /* cannaprotocol_low_sub_h_included_ */
/* [ End of File ] */
