/**@file
 *@brief	ʸȽ
 *@date		Thr,23 Dec,2004 - Sun,26 Dec,2004
 *@date		Tue,09 Jun,2009
 *@date		Thu,14 Oct,2010
 *@date		Sat,07 Sep,2013
 *@date		Tue,17 Sep,2013
 *@date		Mon,10 Oct,2016
 *@author	Copyright(C)2004-2016 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef check_kanji_encoding_h_included_
#define check_kanji_encoding_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif



#ifdef __cplusplus
extern "C" {
#endif



#if !defined(CHECK_KANJI_ENCODING_CHAR1)
# define CHECK_KANJI_ENCODING_CHAR1 "000" /* 󤸤Τ */
#endif
#if !defined(CHECK_KANJI_ENCODING_CHAR2)
# define CHECK_KANJI_ENCODING_CHAR2 "\0\0\0" /* ʤΤʤ */
#endif
#define CHECK_KANJI_ENCODING_CHAR10 ((uint8_t)(CHECK_KANJI_ENCODING_CHAR1[0]))
#define CHECK_KANJI_ENCODING_CHAR11 ((uint8_t)(CHECK_KANJI_ENCODING_CHAR1[1]))
#define CHECK_KANJI_ENCODING_CHAR12 ((uint8_t)(CHECK_KANJI_ENCODING_CHAR1[2]))
#define CHECK_KANJI_ENCODING_CHAR13 ((uint8_t)(CHECK_KANJI_ENCODING_CHAR1[3]))
#define CHECK_KANJI_ENCODING_CHAR20 ((uint8_t)(CHECK_KANJI_ENCODING_CHAR2[0]))
#define CHECK_KANJI_ENCODING_CHAR23 ((uint8_t)(CHECK_KANJI_ENCODING_CHAR2[3]))

#if defined(ICONV_ISO2022JP)
# define CHECK_KANJI_ENCODING_ISO2022JP     (UINT8_C(0x1B) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_ISO2022JP2)
# define CHECK_KANJI_ENCODING_ISO2022JP2    (CHECK_KANJI_ENCODING_ISO2022JP && ('D' == CHECK_KANJI_ENCODING_CHAR23))
#endif
#if defined(ICONV_ISO2022JP3)
# define CHECK_KANJI_ENCODING_ISO2022JP3    (CHECK_KANJI_ENCODING_ISO2022JP && ('O' == CHECK_KANJI_ENCODING_CHAR23))
#endif
#if defined(ICONV_ISO2022JP2004)
# define CHECK_KANJI_ENCODING_ISO2022JP2004 (CHECK_KANJI_ENCODING_ISO2022JP && ('Q' == CHECK_KANJI_ENCODING_CHAR23))
#endif
#if defined(ICONV_EUCJP)
# define CHECK_KANJI_ENCODING_EUCJP         (UINT8_C(0xB4) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_EUCJP)
# define CHECK_KANJI_ENCODING_EUCJP0212     (CHECK_KANJI_ENCODING_EUCJP && (UINT8_C(0x8F) == CHECK_KANJI_ENCODING_CHAR20))
#endif
#if defined(ICONV_EUCJP0213)
# define CHECK_KANJI_ENCODING_EUCJP0213     (CHECK_KANJI_ENCODING_EUCJP && (UINT8_C(0xF4) == CHECK_KANJI_ENCODING_CHAR20))
#endif
#if defined(ICONV_EUCTW)
# define CHECK_KANJI_ENCODING_EUCTW         (UINT8_C(0xE9) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_BIG5)
# define CHECK_KANJI_ENCODING_BIG5          (UINT8_C(0xBA) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_EUCKR)
# define CHECK_KANJI_ENCODING_EUCKR         (UINT8_C(0xF9) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_SHIFTJIS)
# define CHECK_KANJI_ENCODING_SHIFTJIS      (UINT8_C(0x8A) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_SHIFTJIS0213)
# define CHECK_KANJI_ENCODING_SHIFTJIS0213  (UINT8_C(0xEA) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_SHIFTJISCP932)
# define CHECK_KANJI_ENCODING_SHIFTJISCP932 (UINT8_C(0xFA) == CHECK_KANJI_ENCODING_CHAR10)
#endif
#if defined(ICONV_UTF32BE)
# define CHECK_KANJI_ENCODING_UTF32BE        ((UINT8_C(0x00) == CHECK_KANJI_ENCODING_CHAR10) && (UINT8_C(0x00) == CHECK_KANJI_ENCODING_CHAR11) && (UINT8_C(0x6F) == CHECK_KANJI_ENCODING_CHAR12) && (UINT8_C(0x22) == CHECK_KANJI_ENCODING_CHAR13))
#endif
#if defined(ICONV_UTF32LE)
# define CHECK_KANJI_ENCODING_UTF32LE        ((UINT8_C(0x22) == CHECK_KANJI_ENCODING_CHAR10) && (UINT8_C(0x6F) == CHECK_KANJI_ENCODING_CHAR11) && (UINT8_C(0x00) == CHECK_KANJI_ENCODING_CHAR12) && (UINT8_C(0x00) == CHECK_KANJI_ENCODING_CHAR13))
#endif
#if defined(ICONV_UTF16BE)
# define CHECK_KANJI_ENCODING_UTF16BE        ((UINT8_C(0x6F) == CHECK_KANJI_ENCODING_CHAR10) && (UINT8_C(0x22) == CHECK_KANJI_ENCODING_CHAR11) && (UINT8_C(0x00) == CHECK_KANJI_ENCODING_CHAR12) && (UINT8_C(0x30) == CHECK_KANJI_ENCODING_CHAR13))
#endif
#if defined(ICONV_UTF16LE)
# define CHECK_KANJI_ENCODING_UTF16LE        ((UINT8_C(0x22) == CHECK_KANJI_ENCODING_CHAR10) && (UINT8_C(0x6F) == CHECK_KANJI_ENCODING_CHAR11) && (UINT8_C(0x30) == CHECK_KANJI_ENCODING_CHAR12) && (UINT8_C(0x00) == CHECK_KANJI_ENCODING_CHAR13))
#endif
#if defined(ICONV_UTF8)
# define CHECK_KANJI_ENCODING_UTF8          (UINT8_C(0xE6) == CHECK_KANJI_ENCODING_CHAR10)
#endif

#ifndef SRC_KANJI_ENCODING
# define SRC_KANJI_ENCODING ( \
			 (0 + CHECK_KANJI_ENCODING_ISO2022JP2004) ? ""ICONV_ISO2022JP2004 \
			 : ( (0 + CHECK_KANJI_ENCODING_ISO2022JP3) ? ""ICONV_ISO2022JP3 \
				: ( (0 + CHECK_KANJI_ENCODING_ISO2022JP2) ? ""ICONV_ISO2022JP2 \
				   : ( (0 + CHECK_KANJI_ENCODING_ISO2022JP) ? ""ICONV_ISO2022JP \
					  : ( (0 + CHECK_KANJI_ENCODING_EUCJP0212) ? ""ICONV_EUCJP \
						 : ( (0 + CHECK_KANJI_ENCODING_EUCJP0213) ? ""ICONV_EUCJP0213 \
							: ( (0 + CHECK_KANJI_ENCODING_EUCJP) ? ""ICONV_EUCJP \
							   : ( (0 + CHECK_KANJI_ENCODING_EUCTW) ? ""ICONV_EUCTW \
								  : ( (0 + CHECK_KANJI_ENCODING_BIG5) ? ""ICONV_BIG5 \
									 : ( (0 + CHECK_KANJI_ENCODING_EUCKR) ? ""ICONV_EUCKR \
										: ( (0 + CHECK_KANJI_ENCODING_SHIFTJIS0213) ? ""ICONV_SHIFTJIS0213 \
										   : ( (0 + CHECK_KANJI_ENCODING_SHIFTJISCP932) ? ""ICONV_SHIFTJISCP932 \
											  : ( (0 + CHECK_KANJI_ENCODING_SHIFTJIS) ? ""ICONV_SHIFTJIS \
												 : ( (0 + CHECK_KANJI_ENCODING_UTF32BE) ? ""ICONV_UTF32BE \
													: ( (0 + CHECK_KANJI_ENCODING_UTF32LE) ? ""ICONV_UTF32LE \
													   : ( (0 + CHECK_KANJI_ENCODING_UTF16BE) ? ""ICONV_UTF16BE \
														  : ( (0 + CHECK_KANJI_ENCODING_UTF16LE) ? ""ICONV_UTF16LE \
															 : ( (0 + CHECK_KANJI_ENCODING_UTF8) ? ""ICONV_UTF8 \
																: "" )))))))))))))))))
#endif



#ifdef __cplusplus
}
#endif

#endif /* check_kanji_encoding_h_included_ */
/* [ End of File ] */
