/**@file
 *@brief	ʸѴ
 *@date		Mon,16 Sep,2013 - Wed,18 Sep,2013
 *@date		Mon,30 Sep,2013 - Tue,01 Oct,2013
 *@date		Sat,09 Nov,2013
 *@date		Sun,09 Oct,2016 - Mon,10 Oct,2016
 *@author	Copyright(C)2013-2016 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef iconv_wrapper_h_included_
#define iconv_wrapper_h_included_



#ifdef __cplusplus
extern "C" {
#endif



/** ʸֹѡ
 *@attention
 *	iconv_wrapper.c ˤƼơ֥뤬롣
 *	뤳ȡ
 */
enum ENCODING_NUM {
	ENCODING_ASCII = 0,			/**< ASCII */
	ENCODING_EUCJP,				/**< JIS X 0208 EUC-JP */
	ENCODING_EUCJP0212,			/**< JIS X 0212 EUC-JP */
	ENCODING_EUCJP0213,			/**< JIS X 0213 EUC-JP */
	ENCODING_EUCCN,				/**< EUC-CN */
	ENCODING_EUCTW,				/**< EUC-TW */
	ENCODING_BIG5,				/**< Big5 */
	ENCODING_BIG5HKSCS,			/**< Big5-HKSCS */
	ENCODING_EUCKR,				/**< EUC-KR */
	ENCODING_ISO2022JP,			/**< ISO-2022-JP */
	ENCODING_SHIFTJIS,			/**< ShiftJIS JIS X 0208 */
	ENCODING_SHIFTJIS0213,		/**< ShiftJIS JIS X 0213 */
	ENCODING_SHIFTJISCP932,		/**< ShiftJIS Microsoft CP932 */
	ENCODING_UTF8,				/**< UTF-8 */
	ENCODING_UTF16BE,			/**< UTF-16 BigEndian */
	ENCODING_UTF32BE,			/**< UTF-32 BigEndian */
	ENCODING_MAX,				/**< ʼ */
};


/** ʸѴơֹ֥
 *@attention
 *	iconv_wrapper.c ˤƼơ֥뤬롣
 *	뤳ȡ
 */
enum ENCODING_TABLE {
	ENCODING_TABLE_SOURCECODE2INTERNAL = 0,	/**< ɤʸ  ʸ */
	ENCODING_TABLE_LOCALE2INTERNAL,			/**< ʸ  ʸ */
	ENCODING_TABLE_INTERNAL2LOCALE,			/**< ʸ  ʸ */
	ENCODING_TABLE_INTERNAL2CANNAPROTOCOL,	/**< ʸ  ʥץȥʸ */
	ENCODING_TABLE_CANNAPROTOCOL2INTERNAL,	/**< ʥץȥʸ  ʸ */
	ENCODING_TABLE_MAX,						/**< ʼ */
};



extern size_t get_len_mchar(const char str[], size_t len_str, enum ENCODING_NUM enc);
extern size_t wrapper_iconv(enum ENCODING_TABLE enc_tbl, char* const dst, int16_t maxlen_dst, const char* const src, size_t len_src);

extern bool init_iconv(void);
extern bool fin_iconv(void);



#ifdef __cplusplus
}
#endif

#endif /* iconv_wrapper_h_included_ */
/* [ End of File ] */
