/**@file
 *@brief	gettextߤθߴ
 *@date		Fri,20 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef intl_h_included_
#define intl_h_included_



#ifdef __cplusplus
extern "C" {
#endif



#if defined(ENABLE_NLS)
# if defined(HAVE_LIBINTL_H)
#  include <libintl.h>
# endif
# define _(arg) dgettext(PACKAGE,arg)
# if defined(gettext_noop)
#  define N_(arg) gettext_noop(arg)
# else
#  define N_(arg) (arg)
# endif
#else
# define _(arg) (arg)
# define N_(arg) (arg)
# define gettext(arg) (arg)
# define dgettext(arg1,arg2) (arg2)
# define dcgettext(arg1,arg2,arg3) (arg2)
#endif



#ifdef __cplusplus
}
#endif

#endif /* intl_h_included_ */
/* [ End of File ] */
