/**@file
 *@brief	anthy-agentץȥʹؿ顧ޥɤν
 *@date		Fri,23 Aug,2013 - Mon,30 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif

#include "args.h"
#include "iconv_wrapper.h"
#include "parseline_low_sub.h"
#include "parseline_common.h"
#include "parseline_cmd.h"
#include "parseline_rk.h"
#include "cannaprotocol_wchar.h"
#include "cannaprotocol_common.h"
#include "cannaprotocol_low.h"
#include "cannaprotocol.h"



/** 桼Ϥˤ륳ޥɰʥѡ̡
 */
enum parseline_keycmd_key_list_t {
	KEY_SENTINEL,
	KEY_SPACE,
	KEY_OPAR,
	KEY_CPAR,
	KEY_ENTER,
	KEY_ESC,
	KEY_BACKSPACE,
	KEY_DELETE,
	KEY_LEFT,
	KEY_RIGHT,
	KEY_UP,

	KEY_DOWN,
	KEY_J,
	KEY_H,
	KEY_D,
	KEY_A,
	KEY_E,
	KEY_K,

	KEY_SHIFT = 0x0100,
	KEY_CTRL  = 0x0200,
	KEY_ALT   = 0x0400,
};


/** 桼Ϥˤ륳ޥɰʸ󢪥ѡ̡ˡ
 */
struct parseline_keycmd_str2key_list_t {
	const char* const tag;				/**< ޥʸ */
	enum parseline_keycmd_key_list_t key;		/**< ѡ */
	bool modifier;						/**< ᥿ʸ */
};


/** 桼Ϥˤ륳ޥɰʸ󢪥ѡ̡
 */
static const struct parseline_keycmd_str2key_list_t parseline_keycmd_str2key_list[] = {
	{ "shift",		KEY_SHIFT,		1 },
	{ "ctrl",		KEY_CTRL,		1 },
	{ "alt",		KEY_ALT,		1 },

	{ "space",		KEY_SPACE,		0 },
	{ "opar",		KEY_OPAR,		0 },
	{ "cpar",		KEY_CPAR,		0 },
	{ "enter",		KEY_ENTER,		0 },
	{ "esc",		KEY_ESC,		0 },
	{ "backspace",	KEY_BACKSPACE,	0 },
	{ "delete",		KEY_DELETE,		0 },
	{ "left",		KEY_LEFT,		0 },
	{ "right",		KEY_RIGHT,		0 },
	{ "up",			KEY_UP,			0 },
	{ "down",		KEY_DOWN,		0 }, /* anthy-agent  KEY_DOWN ˺ܤäƤʤΤġġ */

	{ "J",			KEY_J,			0 },
	{ "H",			KEY_H,			0 },
	{ "D",			KEY_D,			0 },
	{ "A",			KEY_A,			0 },
	{ "E",			KEY_E,			0 },
	{ "K",			KEY_K,			0 },

	{ NULL,			0,				0 },
};



/** ޥɤ⤷̾Ϥѡ
 *@param[in,out]	apct				̿Ѿ
 *@param[in]		buf					Ϥ줿ʸ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Wed,28 Aug,2013 - Sun,01 Sep,2013
 *@date		Mon,02 Sep,2013
 *@date		Thu,05 Sep,2013
 *@date		Sun,08 Sep,2013
 *@date		Thu,12 Sep,2013 - Fri,13 Sep,2013
 *@date		Mon,16 Sep,2013
 *@date		Mon,30 Sep,2013
 */
void parseline_keycmd(struct agent_parser_context_transaction_t* const apct, const char buf[])
{
	assert (NULL != apct);
	assert (NULL != buf);


	const char* ptr = buf;

	const char separator[] = {
		'\r', '\n',
		PARSELINE_KEYCMD_START,
		apct->toggle_key,
		'\0'
	};

	/* ʸѡ */
	while ('\0' != (*ptr)) {

		/* ʸѡ */
		const uint_fast8_t c0 = (uint_fast8_t)(                 ('\0' != *(ptr+0))  ? (unsigned char)*(ptr+0) : '\0');
		const uint_fast8_t c1 = (uint_fast8_t)((('\0' != c0) && ('\0' != *(ptr+1))) ? (unsigned char)*(ptr+1) : '\0');
		const uint_fast8_t c2 = (uint_fast8_t)((('\0' != c1) && ('\0' != *(ptr+2))) ? (unsigned char)*(ptr+2) : '\0');
		const uint_fast8_t c3 = (uint_fast8_t)((('\0' != c2) && ('\0' != *(ptr+3))) ? (unsigned char)*(ptr+3) : '\0');

		string_internal_t str[PENDING_BUFSIZE] = { '\0' };
		char str_rk[PENDING_BUFSIZE][PENDING_BUFSIZE]; memset(str_rk, '\0', sizeof(str_rk));
		int_fast16_t str_movelen = 0;
		size_t ptr_movelen = 0;
		const int ptr_type_eucjp = cannaprotocol_is_char_eucjp_fast(c0, c1, c2);
		const size_t ptr_type_utf8 = get_len_mchar(ptr, 4, ENCODING_UTF8);

		if ((UINT8_C('\r') == c0) || (UINT8_C('\n') == c0)) {
			/* פʸ */
			break;

		} else if (UINT8_C(PARSELINE_KEYCMD_START) == c0) {
			/* ޥɳʸ */
			const char* const ptr_end = strchr(ptr, PARSELINE_KEYCMD_END);
			if (NULL == ptr_end) {
				break;
			}
			str_movelen = 0;
			ptr_movelen = (size_t)(ptr_end - ptr + 1);
			const char* ptr_command = ptr + 1;

			unsigned int cmd = 0;
			while (ptr_command < ptr_end) {
				const char* ptr_delimiter = strchr(ptr_command, PARSELINE_KEYCMD_DELIMITER);
				if ((NULL == ptr_delimiter) || (ptr_end < ptr_delimiter)) {
					ptr_delimiter = ptr_end;
				}

				const size_t len_ptr_command = (size_t)(ptr_delimiter - ptr_command);
				const struct parseline_keycmd_str2key_list_t* cl;
				for (cl = parseline_keycmd_str2key_list; (NULL != cl->tag); ++cl) {
					if (0 == strncmp(cl->tag, ptr_command, len_ptr_command)) {
						break;
					}
				}
				if (NULL != cl->tag) {
					cmd |= cl->key;
					if (!cl->modifier) {
						break;
					}
				}

				ptr_command = (ptr_delimiter + 1);
			}
			/* ޥɼ¹ */
			switch (cmd) {
			case KEY_SPACE:					parseline_keycmd_arrow_ud(apct, +1);		break;
			case KEY_OPAR:					str[0] = '('; str_movelen =1;				break;
			case KEY_CPAR:					str[0] = ')'; str_movelen =1;				break;
			case (KEY_CTRL  | KEY_J):
			case KEY_DOWN:
			case KEY_ENTER:					parseline_keycmd_enter(apct);				break;
			case KEY_ESC:					parseline_keycmd_esc(apct);					break;
			case (KEY_CTRL  | KEY_H):
			case KEY_BACKSPACE:				parseline_keycmd_backspace(apct);			break;
			case (KEY_CTRL  | KEY_D):
			case KEY_DELETE:				parseline_keycmd_delete(apct);				break;
			case KEY_LEFT:					parseline_keycmd_arrow_lr(apct, -1);		break;
			case KEY_RIGHT:					parseline_keycmd_arrow_lr(apct, +1);		break;
			case KEY_UP:					parseline_keycmd_arrow_ud(apct, -1);		break;
			case (KEY_SHIFT | KEY_LEFT):	parseline_keycmd_shift_arrow_lr(apct, -1);	break;
			case (KEY_SHIFT | KEY_RIGHT):	parseline_keycmd_shift_arrow_lr(apct, +1);	break;
			case (KEY_CTRL  | KEY_A):		parseline_keycmd_gobol(apct);				break;
			case (KEY_CTRL  | KEY_E):		parseline_keycmd_goeol(apct);				break;
			case (KEY_CTRL  | KEY_K):		parseline_keycmd_cut(apct);					break;
			default:						break;
			}

		} else if ((!args.cannaprotocol.unicode) && (0 < ptr_type_eucjp)) {
			/* EUC-JP ľ */
			str_movelen = 1;
			if (2 == ptr_type_eucjp) {
				str[0] = cannaprotocol_eucjpG2_to_strinternal(c1);
				ptr_movelen = 2;
			} else if (3 == ptr_type_eucjp) {
				str[0] = cannaprotocol_eucjpG3_to_strinternal(c1, c2);
				ptr_movelen = 3;
			} else if (1 == ptr_type_eucjp) {
				str[0] = cannaprotocol_eucjpG1_to_strinternal(c0, c1);
				ptr_movelen = 2;
			}

		} else if ((args.cannaprotocol.unicode) && (1 < ptr_type_utf8)) {
			/* UTF-8 ľ */
			str_movelen = 1;
			if (1 == ptr_type_utf8) {
				str[0] = (string_internal_fast_t)c0;
				ptr_movelen = 1;
			} else if (2 == ptr_type_utf8) {
				str[0] = ((string_internal_fast_t)c0 << 8) | (string_internal_fast_t)c1;
				ptr_movelen = 2;
			} else if (3 == ptr_type_utf8) {
				str[0] = ((string_internal_fast_t)c0 << 16) | ((string_internal_fast_t)c1 << 8) | (string_internal_fast_t)c2;
				ptr_movelen = 3;
			} else if (4 == ptr_type_utf8) {
				str[0] = ((string_internal_fast_t)c0 << 24) | ((string_internal_fast_t)c1 << 16) | ((string_internal_fast_t)c2 << 8) | (string_internal_fast_t)c3;
				ptr_movelen = 4;
			} else {
				/* Illigal State */
				str[0] = (string_internal_fast_t)c0;
				ptr_movelen = 1;
			}

		} else if ((char)c0 == apct->toggle_key) {
			/* ľϤؤΰڤؤ */
			apct->input.pending_str[0] = '\0';
			apct->rk_map_direct_mode = !apct->rk_map_direct_mode;
			ptr_movelen = 1;

		} else {
			if (apct->rk_map_direct_mode) {
				/* ľϥ⡼ */
				str[0] = c0;
				str_movelen = 1;
				ptr_movelen = 1;
			} else {
				/* RKޥå׻ʸ */
				const size_t len_pending_str = strlen(apct->input.pending_str);
				const char* const ptr_separator = strpbrk(ptr, separator);
				ptr_movelen = (NULL == ptr_separator) ? strlen(ptr) : (size_t)(ptr_separator - ptr);
				if ((len_pending_str + ptr_movelen) < number_(apct->input.pending_str)) {
					for (size_t i = 0; i < ptr_movelen; ++i){
						if (UINT8_C(0x80) <= (unsigned char)ptr[i]) {
							ptr_movelen = i;
							break;
						}
						apct->input.pending_str[len_pending_str+i] = (char)cannaprotocol_eucjpG0_to_strinternal((unsigned char)ptr[i]);
					}
					apct->input.pending_str[len_pending_str+ptr_movelen] = '\0';

					if ((apct->preedit_mode)
						&& (0 < apct->input.cursor_ptr)
						&& (0 < apct->input.str_rk[apct->input.cursor_ptr - 1][0])
						&& (0 < strlen(apct->input.str_rk[apct->input.cursor_ptr - 1]))
					) {
						string_internal_t str_preeditmode[PENDING_BUFSIZE] = { '\0' };
						char str_rk_preeditmode[PENDING_BUFSIZE] = { '\0' };

						const size_t str_preeditmode_movelen = parseline_rk_preedit(apct, apct->input.str_rk[apct->input.cursor_ptr - 1], apct->input.pending_str, number_(apct->input.pending_str), str_preeditmode, str_rk_preeditmode, number_(str_preeditmode));
						if (0 < str_preeditmode_movelen) {
							memcpy(&(apct->input.str[apct->input.cursor_ptr - 1]), str_preeditmode, (sizeof(str_preeditmode[0]) * (size_t)str_preeditmode_movelen));
							for (size_t i = 0; i < (str_preeditmode_movelen - 1); ++i) {
								apct->input.str_rk[(size_t)apct->input.cursor_ptr + i][0] = -1;
							}
							strlcpy(&(apct->input.str_rk[apct->input.cursor_ptr - 1][0]), str_rk_preeditmode, number_(apct->input.str_rk[apct->input.cursor_ptr]));
						}
					}

					str_movelen = (int_fast16_t)parseline_rk(apct, apct->input.pending_str, number_(apct->input.pending_str), str, str_rk, number_(str));
				}
			}
		}


		/* ʸѡˤ */
		ptr += ptr_movelen;
		switch (apct->input_state) {
		case PARSELINE_INPUT_STATE_INIT:
			if ((0 < str_movelen) || ('\0' != apct->input.pending_str[0])) {
				apct->input_state = PARSELINE_INPUT_STATE_INPUT;
			}
			break;
		case PARSELINE_INPUT_STATE_INPUT:
			break;
		case PARSELINE_INPUT_STATE_CONV:
		case PARSELINE_INPUT_STATE_EDITSEG:
			if (0 < str_movelen) {
				parseline_keycmd_commit(apct);
			}
			break;
		}

		/* ʸѡ̳Ǽ */
		if (0 < str_movelen) {
			if ((size_t)(apct->input.len + str_movelen) < number_(apct->input.str)) {
				if (apct->input.len != apct->input.cursor_ptr) {
					memmove(&(apct->input.str[apct->input.cursor_ptr + str_movelen]), &(apct->input.str[apct->input.cursor_ptr]), (sizeof(apct->input.str[0]) * (size_t)(apct->input.len - apct->input.cursor_ptr)));
					memmove(&(apct->input.str_rk[apct->input.cursor_ptr + str_movelen][0]), &(apct->input.str_rk[apct->input.cursor_ptr][0]), (sizeof(apct->input.str_rk[0]) * (size_t)(apct->input.len - apct->input.cursor_ptr)));
				}
				memcpy(&(apct->input.str[apct->input.cursor_ptr]), str, (sizeof(str[0]) * (size_t)str_movelen));
				memcpy(&(apct->input.str_rk[apct->input.cursor_ptr][0]), str_rk, (sizeof(str_rk[0]) * (size_t)str_movelen));
				apct->input.len        += str_movelen;
				apct->input.cursor_ptr += str_movelen;
			}
		}
		if ((0 == apct->input.len) && ('\0' == apct->input.pending_str[0])) {
			apct->input_state = PARSELINE_INPUT_STATE_INIT;
		}
	}
	return;
}

/* [ End of File ] */
