/**@file
 *@brief	anthy-agentץȥʹؿ顧ʬ
 *@date		Thu,05 Sep,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif

#include "iconv_wrapper.h"
#include "parseline_low_sub.h"



/** ޥɼ¹Դλɽ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_show_ok(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	apct->output.before_locale[0] = '\0';

	strlcat(apct->output.before_locale, "OK\r\n", number_(apct->output.before_locale));

	wrapper_iconv(ENCODING_TABLE_INTERNAL2LOCALE, apct->output.after_locale, number_(apct->output.after_locale), apct->output.before_locale, strlen(apct->output.before_locale));
	fputs(apct->output.after_locale, stdout);
	return;
}

/** ޥɼ¹ԼԤɽ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_show_err(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	apct->output.before_locale[0] = '\0';

	strlcat(apct->output.before_locale, "ERR\r\n", number_(apct->output.before_locale));

	wrapper_iconv(ENCODING_TABLE_INTERNAL2LOCALE, apct->output.after_locale, number_(apct->output.after_locale), apct->output.before_locale, strlen(apct->output.before_locale));
	fputs(apct->output.after_locale, stdout);
	return;
}

/** Ѵɽ
 *@param[in,out]	apct				̿Ѿ
 *@param			phrase				ɽʸֹ
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_show_candidate(struct agent_parser_context_transaction_t* const apct, int_fast16_t phrase)
{
	assert (NULL != apct);

	apct->output.before_locale[0] = '\0';
	char buf[STR_BUFSIZE];

	strlcat(apct->output.before_locale, "(\"", number_(apct->output.before_locale));

	const int_fast16_t selected_candidacy = apct->converted.selected_candidacy[phrase];
	if (0 <= selected_candidacy) {
		parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), apct->converted.str[phrase][selected_candidacy], apct->converted.len_str[phrase][selected_candidacy]);
	} else {
		parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), &(apct->input.str[apct->converted.ptr_yomi[phrase]]), apct->converted.len_yomi[phrase]);
	}

	snprintf(buf, number_(buf), "\" %d %d)", (int)selected_candidacy, (int)apct->converted.num_candidacy[phrase]);
	strlcat(apct->output.before_locale, buf, number_(apct->output.before_locale));

	strlcat(apct->output.before_locale, "\r\n", number_(apct->output.before_locale));

	wrapper_iconv(ENCODING_TABLE_INTERNAL2LOCALE, apct->output.after_locale, number_(apct->output.after_locale), apct->output.before_locale, strlen(apct->output.before_locale));
	fputs(apct->output.after_locale, stdout);
	return;
}

/** Ѵʸɽ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Thu,05 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_show_stat(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	apct->output.before_locale[0] = '\0';
	char buf[STR_BUFSIZE];

	snprintf(buf, number_(buf), "(%1d", apct->input_state);
	strlcat(apct->output.before_locale, buf, number_(apct->output.before_locale));

	if ('\0' != apct->commit.str[0]) {
		strlcat(apct->output.before_locale, " ((COMMIT) \"", number_(apct->output.before_locale));
		strlcat(apct->output.before_locale, apct->commit.str, number_(apct->output.before_locale));
		strlcat(apct->output.before_locale, "\")", number_(apct->output.before_locale));
		apct->commit.str[0] = '\0';
	}

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		{
			const int_fast16_t len1 = apct->input.cursor_ptr;
			const size_t       lenp = strlen(apct->input.pending_str);
			const int_fast16_t len2 = (apct->input.len - apct->input.cursor_ptr);
			if (0 < len1) {
				strlcat(apct->output.before_locale, " ((UL) \"", number_(apct->output.before_locale));
				parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), &(apct->input.str[0]), len1);
				strlcat(apct->output.before_locale, "\" -1 -1)", number_(apct->output.before_locale));
			}
			if (0 < lenp) {
				strlcat(apct->output.before_locale, " ((UL) \"", number_(apct->output.before_locale));
				strlcat(apct->output.before_locale, apct->input.pending_str, number_(apct->output.before_locale));
				strlcat(apct->output.before_locale, "\" -1 -1)", number_(apct->output.before_locale));
			}
			strlcat(apct->output.before_locale, " cursor", number_(apct->output.before_locale));
			if (0 < len2) {
				strlcat(apct->output.before_locale, " ((UL) \"", number_(apct->output.before_locale));
				parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), &(apct->input.str[apct->input.cursor_ptr]), len2);
				strlcat(apct->output.before_locale, "\" -1 -1)", number_(apct->output.before_locale));
			}
		}
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		{
			for (int_fast16_t phrase = 0; phrase < apct->converted.num_phrase; ++ phrase) {
				if (phrase == apct->converted.cursor_ptr) {
					strlcat(apct->output.before_locale, " ((UL RV) \"", number_(apct->output.before_locale));
				} else {
					strlcat(apct->output.before_locale, " ((UL) \"", number_(apct->output.before_locale));
				}

				const int_fast16_t selected_candidacy = apct->converted.selected_candidacy[phrase];
				if (0 <= selected_candidacy) {
					parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), apct->converted.str[phrase][selected_candidacy], apct->converted.len_str[phrase][selected_candidacy]);
				} else {
					parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), &(apct->input.str[apct->converted.ptr_yomi[phrase]]), apct->converted.len_yomi[phrase]);
				}

				snprintf(buf, number_(buf), "\" %d %d)", (int)selected_candidacy, (int)apct->converted.num_candidacy[phrase]);
				strlcat(apct->output.before_locale, buf, number_(apct->output.before_locale));
			}
		}
		break;
	}

	strlcat(apct->output.before_locale, ")\r\n", number_(apct->output.before_locale));

	wrapper_iconv(ENCODING_TABLE_INTERNAL2LOCALE, apct->output.after_locale, number_(apct->output.after_locale), apct->output.before_locale, strlen(apct->output.before_locale));
	fputs(apct->output.after_locale, stdout);
	return;
}

/* [ End of File ] */
