/**@file
 *@brief	anthy-agentץȥʹؿ顧ʸɽ
 *@date		Sat,31 Aug,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h> /* for OpenBSD, netinet/in.h must faster than arpa/inet.h */
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif

#include "cannaprotocol_wchar.h"
#include "parseline_low_sub.h"



/** ʸѴ
 *@param[in,out]	dst					Ѵ
 *@param			max_len				ѴΥХåե
 *@param			ptr					ɽʸ
 *@param			len					ɽĹ
 *
 *@author	G-HAL
 *@date		Sat,31 Aug,2013
 *@date		Thu,05 Sep,2013
 *@date		Tue,01 Oct,2013
 */
void parseline_conv_strinternal_to_charstr(char* const dst, size_t max_len, const string_internal_t ptr[], int_fast16_t len)
{
	assert (NULL != dst);
	assert (NULL != ptr);

	const string_internal_t* ptr_str = ptr;
	const size_t len_dst = strlen(dst);
	assert (len_dst <= max_len);
	char* ptr_dst = &(dst[len_dst]);
	max_len -= len_dst;
	for (int_fast16_t i = len; 0 < i; --i, ++ptr_str) {
		if (max_len < 4) {
			break;
		}

		const string_internal_fast_t c = (*ptr_str);
		/* EUC-JP  UTF-8 */
		const uint_fast8_t c0 = ((uint_fast8_t)(c >>  0) & UINT8_C(0xFF));
		const uint_fast8_t c1 = ((uint_fast8_t)(c >>  8) & UINT8_C(0xFF));
		const uint_fast8_t c2 = ((uint_fast8_t)(c >> 16) & UINT8_C(0xFF));
		const uint_fast8_t c3 = ((uint_fast8_t)(c >> 24) & UINT8_C(0xFF));
		if (c <= UINT32_C(0x0000FF)) {
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		} else if (c <= UINT32_C(0x00FFFF)) {
			(*ptr_dst ++) = (char)c1;
			-- max_len;
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		} else if (c <= UINT32_C(0xFFFFFF)) {
			(*ptr_dst ++) = (char)c2;
			-- max_len;
			(*ptr_dst ++) = (char)c1;
			-- max_len;
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		} else {
			(*ptr_dst ++) = (char)c3;
			-- max_len;
			(*ptr_dst ++) = (char)c2;
			-- max_len;
			(*ptr_dst ++) = (char)c1;
			-- max_len;
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		}
	}
	(*ptr_dst) = '\0';
	return;
}

/** ʸɽ
 *@param[in,out]	dst					Ѵ
 *@param			max_len				ѴΥХåե
 *@param			ptr					ɽʸ
 *@param			len					ɽĹ
 *
 *@author	G-HAL
 *@date		Sat,31 Aug,2013
 *@date		Sun,08 Sep,2013
 *@date		Thu,19 Sep,2013
 *@date		Tue,01 Oct,2013
 */
void parseline_conv_wstr_to_charstr(char* const dst, size_t max_len, const string16_t ptr[], int_fast16_t len)
{
	assert (NULL != dst);
	assert (NULL != ptr);

	const string16_t* ptr_str = ptr;
	const size_t len_dst = strlen(dst);
	assert (len_dst <= max_len);
	char* ptr_dst = &(dst[len_dst]);
	max_len -= len_dst;
	for (int_fast16_t i = len; 0 < i; --i, ++ptr_str) {
		if (max_len < 4) {
			break;
		}

		const string_internal_fast_t c = cannaprotocol_wchar_to_eucjp(ntohs(*ptr_str));
		/* EUC-JP  UTF-8 */
		const uint_fast8_t c0 = ((uint_fast8_t)(c >>  0) & UINT8_C(0xFF));
		const uint_fast8_t c1 = ((uint_fast8_t)(c >>  8) & UINT8_C(0xFF));
		const uint_fast8_t c2 = ((uint_fast8_t)(c >> 16) & UINT8_C(0xFF));
		const uint_fast8_t c3 = ((uint_fast8_t)(c >> 24) & UINT8_C(0xFF));
		if (c <= UINT32_C(0x0000FF)) {
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		} else if (c <= UINT32_C(0x00FFFF)) {
			(*ptr_dst ++) = (char)c1;
			-- max_len;
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		} else if (c <= UINT32_C(0xFFFFFF)) {
			(*ptr_dst ++) = (char)c2;
			-- max_len;
			(*ptr_dst ++) = (char)c1;
			-- max_len;
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		} else {
			(*ptr_dst ++) = (char)c3;
			-- max_len;
			(*ptr_dst ++) = (char)c2;
			-- max_len;
			(*ptr_dst ++) = (char)c1;
			-- max_len;
			(*ptr_dst ++) = (char)c0;
			-- max_len;
		}
	}
	(*ptr_dst) = '\0';
	return;
}

/* [ End of File ] */
