/**@file
 *@brief	anthy-agentץȥʹؿRKѴ
 *@date		Thu,29 Aug,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif

#include "environment_check.h"
#include "intl.h"
#include "logger.h"
#include "alternative_strlcpy.h"
#include "args.h"
#include "iconv_wrapper.h"
#include "cannaprotocol_wchar.h"
#include "parseline_common.h"
#include "parseline_rk.h"



/** 桼ƤRKѴơ֥Ѵ
 *@param[in]		apct				ߤΥƥ
 *@param[in,out]	pending_str			ϡϤ줿ʸ󡢽ϡڥǥ󥰤ʸ
 *@param			maxlen_pending_str	pending_str ˳ǼǤʸĹ
 *@param[out]		output_str			ѴϤ줿ʸ
 *@param[out]		output_str_rk		output_str[] бϤ줿ʸ
 *@param			maxlen_output_str	output_str ˳ǼǤʸĹ
 *@return								Ϥ줿ʸĹ
 *
 *@author	G-HAL
 *@date		Thu,29 Aug,2013
 *@date		Mon,02 Sep,2013
 *@date		Thu,05 Sep,2013
 *@date		Fri,06 Sep,2013
 *@date		Sun,08 Sep,2013
 *@date		Wed,11 Sep,2013
 *@date		Fri,13 Sep,2013
 *@date		Sat,14 Sep,2013
 */
size_t parseline_rk(struct agent_parser_context_transaction_t* const apct, char pending_str[], size_t maxlen_pending_str, string_internal_t* const output_str, char (*output_str_rk)[PENDING_BUFSIZE], size_t maxlen_output_str)
{
	assert (NULL != apct);
	assert (NULL != pending_str);
	assert (NULL != output_str);
	assert (NULL != output_str_rk);


	string_internal_t* output_ptr = output_str;
	char (*output_ptr_rk)[PENDING_BUFSIZE] = output_str_rk;
	size_t num_output_str = 0;

REPEAT:
	{
		const size_t len_pending_str = strlen(pending_str);
		for (size_t ptr_start = 0; ptr_start < len_pending_str; ++ ptr_start) {
			for (size_t len_ptr = (len_pending_str - ptr_start); 0 < len_ptr; -- len_ptr) {

				for (const struct rk_map_t* rk_map_ptr = apct->rk_map_table->rk_map_index->rk_map[(unsigned char)pending_str[0]]; NULL != rk_map_ptr; rk_map_ptr = rk_map_ptr->next) {
					if (len_ptr != rk_map_ptr->len_input) {
						continue;
					}
					const int cmp = strncmp(&(pending_str[ptr_start]), rk_map_ptr->input, len_ptr);
					if (0 == cmp) {
						/* RKѴ */

						/* ڥǥʸν */
						char new_pending_str[maxlen_pending_str];
						strlcpy(new_pending_str, rk_map_ptr->pending, number_(new_pending_str));
						strlcat(new_pending_str, &(pending_str[ptr_start + len_ptr]), number_(new_pending_str));
						memcpy(pending_str, new_pending_str, (sizeof(pending_str[0]) * maxlen_pending_str));
						strlcpy(&(output_ptr_rk[0][0]), rk_map_ptr->input, number_(output_ptr_rk[0]));

						/* ʸν */
						for (const string_internal_t* ptr = rk_map_ptr->output; '\0' != ptr[0]; ++ptr) {
							(*output_ptr ++) = (*ptr);
							++ output_ptr_rk; (*output_ptr_rk)[0] = -1;
							++ num_output_str;
							if (maxlen_output_str <= num_output_str) {
								return num_output_str;
							}
						}

						goto REPEAT;
					}
				}

			}
		}
	}
	return num_output_str;
}



/** 桼ƤRKѴơ֥Ѵpreedit_modeѡ
 *@param[in]		apct				ߤΥƥ
 *@param[in]		preedit_str			ϺѤߤʸ
 *@param[in,out]	pending_str			ϡɲϤ줿ʸ󡢽ϡڥǥ󥰤ʸ
 *@param			maxlen_pending_str	pending_str ˳ǼǤʸĹ
 *@param[out]		output_str			ѴϤ줿ʸ
 *@param[out]		output_str_rk		output_str б rkʸ
 *@param			maxlen_output_str	output_str  output_str_rk ˳ǼǤʸĹ
 *@return								Ϥ줿ʸĹ
 *
 *@author	G-HAL
 *@date		Mon,16 Sep,2013
 */
size_t parseline_rk_preedit(struct agent_parser_context_transaction_t* const apct, char preedit_str[], char pending_str[], size_t maxlen_pending_str, string_internal_t* const output_str, char* const output_str_rk, size_t maxlen_output_str)
{
	assert (NULL != apct);
	assert (NULL != preedit_str);
	assert (NULL != pending_str);
	assert (NULL != output_str);
	assert (NULL != output_str_rk);


	string_internal_t* output_ptr = output_str;
	size_t num_output_str = 0;

	{
		char str_rk[PENDING_BUFSIZE] = { '\0' };
		strlcpy(str_rk, preedit_str, number_(str_rk));
		strlcat(str_rk, pending_str, number_(str_rk));

		for (size_t len_ptr = strlen(str_rk); 0 < len_ptr; -- len_ptr) {

			for (const struct rk_map_t* rk_map_ptr = apct->rk_map_table->rk_map_index->rk_map[(unsigned char)str_rk[0]]; NULL != rk_map_ptr; rk_map_ptr = rk_map_ptr->next) {
				if (len_ptr != rk_map_ptr->len_input) {
					continue;
				}
				const int cmp = strncmp(str_rk, rk_map_ptr->input, len_ptr);
				if (0 == cmp) {
					/* RKѴ */

					/* ڥǥʸν */
					const size_t len_preedit_str = strlen(preedit_str);
					const size_t len_start = (len_ptr - len_preedit_str);
					memmove(pending_str, &(pending_str[len_start]), (maxlen_pending_str - len_start));
					strlcpy(output_str_rk, rk_map_ptr->input, maxlen_output_str);

					/* ʸν */
					for (const string_internal_t* ptr = rk_map_ptr->output; '\0' != ptr[0]; ++ptr) {
						(*output_ptr ++) = (*ptr);
						++ num_output_str;
						if (maxlen_output_str <= num_output_str) {
							return num_output_str;
						}
					}

					return num_output_str;
				}
			}

		}
	}
	return 0;
}



/** RKѴơ֥β
 *@param[in,out]	tbl					ޥå
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Wed,11 Sep,2013
 */
bool parseline_rk_clear_map(struct rk_map_tables_t* const tbl)
{
	assert (NULL != tbl);

	for (size_t i = 0; i < number_(tbl->rk_map_index->rk_map); ++i) {
		struct rk_map_t* ptr = tbl->rk_map_index->rk_map[i];
		tbl->rk_map_index->rk_map[i] = NULL;
		struct rk_map_t* next;
		for (; NULL != ptr; ptr = next) {
			next = ptr->next;
			free(ptr);
		}
	}

	free(tbl->rk_map_index);
	tbl->rk_map_index = NULL;
	return true;
}


/** RKѴơ֥
 *@param[in,out]	tbl					ޥå
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Wed,11 Sep,2013
 *@date		Wed,18 Sep,2013
 *@date		Mon,30 Sep,2013
 */
bool parseline_rk_build_map(struct rk_map_tables_t* const tbl)
{
	assert (NULL != tbl);

	tbl->rk_map_index = malloc(sizeof(struct rk_map_index_t));
	if (NULL == tbl->rk_map_index) {
		LOGGER_CRIT(l,N_("Out of memory at %1$s"), "parseline_rk_build_map()");
		return false;
	}
	for (size_t i = 0; i < number_(tbl->rk_map_index->rk_map); ++i) {
		tbl->rk_map_index->rk_map[i] = NULL;
	}

	for (const struct rk_map_source_t* rk_map_source = tbl->rk_map_source; NULL != rk_map_source->input; ++rk_map_source) {
		char iconv_buf[PENDING_BUFSIZE];

		struct rk_map_t* dst = malloc(sizeof(struct rk_map_t));
		if (NULL == dst) {
			LOGGER_CRIT(l,N_("Out of memory at %1$s"), "parseline_rk_build_map()");
			return false;
		}

		/* ¦ʸ */
		dst->len_input = wrapper_iconv(ENCODING_TABLE_SOURCECODE2INTERNAL, iconv_buf, number_(iconv_buf), rk_map_source->input, strlen(rk_map_source->input));
		strlcpy(dst->input, iconv_buf, number_(dst->input));

		/* ǥå³ */
		dst->next = tbl->rk_map_index->rk_map[(unsigned char)iconv_buf[0]];
		tbl->rk_map_index->rk_map[(unsigned char)iconv_buf[0]] = dst;

		/* ڥǥ󥰤ʸ */
		wrapper_iconv(ENCODING_TABLE_SOURCECODE2INTERNAL, iconv_buf, number_(iconv_buf), rk_map_source->pending, strlen(rk_map_source->pending));
		strlcpy(dst->pending, iconv_buf, number_(dst->pending));

		/* ¦ʸ */
		wrapper_iconv(ENCODING_TABLE_SOURCECODE2INTERNAL, iconv_buf, number_(iconv_buf), rk_map_source->output, strlen(rk_map_source->output));
		string_internal_t* output_ptr = dst->output;
		for (const char* input_ptr = iconv_buf; '\0' != (*input_ptr);) {

			const uint_fast8_t c0 = (uint_fast8_t)(                 ('\0' != *(input_ptr+0))  ? (unsigned char)*(input_ptr+0) : '\0');
			const uint_fast8_t c1 = (uint_fast8_t)((('\0' != c0) && ('\0' != *(input_ptr+1))) ? (unsigned char)*(input_ptr+1) : '\0');
			const uint_fast8_t c2 = (uint_fast8_t)((('\0' != c1) && ('\0' != *(input_ptr+2))) ? (unsigned char)*(input_ptr+2) : '\0');
			const uint_fast8_t c3 = (uint_fast8_t)((('\0' != c2) && ('\0' != *(input_ptr+3))) ? (unsigned char)*(input_ptr+3) : '\0');

			string_internal_fast_t str = '\0';
			size_t ptr_movelen = 0;
			if ((UINT8_C('\r') == c0) || (UINT8_C('\n') == c0)) {
				/* פʸ */
				break;

			} else if (!args.cannaprotocol.unicode) {
				/* EUC-JP */
				const int ptr_type_eucjp = cannaprotocol_is_char_eucjp_fast(c0, c1, c2);
				if (2 == ptr_type_eucjp) {
					str = cannaprotocol_eucjpG2_to_strinternal(c1);
					ptr_movelen = 2;

				} else if (3 == ptr_type_eucjp) {
					str = cannaprotocol_eucjpG3_to_strinternal(c1, c2);
					ptr_movelen = 3;

				} else if (1 == ptr_type_eucjp) {
					str = cannaprotocol_eucjpG1_to_strinternal(c0, c1);
					ptr_movelen = 2;

				} else {
					str = cannaprotocol_eucjpG0_to_strinternal(c0);
					ptr_movelen = 1;
				}

			} else if (args.cannaprotocol.unicode) {
				/* UTF-8 */
				const size_t ptr_type_utf8 = get_len_mchar(input_ptr, 4, ENCODING_UTF8);
				if (1 == ptr_type_utf8) {
					str = (string_internal_fast_t)c0;
					ptr_movelen = 1;
				} else if (2 == ptr_type_utf8) {
					str = ((string_internal_fast_t)c0 << 8) | (string_internal_fast_t)c1;
					ptr_movelen = 2;
				} else if (3 == ptr_type_utf8) {
					str = ((string_internal_fast_t)c0 << 16) | ((string_internal_fast_t)c1 << 8) | (string_internal_fast_t)c2;
					ptr_movelen = 3;
				} else if (4 == ptr_type_utf8) {
					str = ((string_internal_fast_t)c0 << 24) | ((string_internal_fast_t)c1 << 16) | ((string_internal_fast_t)c2 << 8) | (string_internal_fast_t)c3;
					ptr_movelen = 4;
				} else {
					/* Illigal State */
					str = (string_internal_fast_t)c0;
					ptr_movelen = 1;
				}

			} else {
				/* Illigal State */
				str = c0;
				ptr_movelen = 1;
			}

			(*output_ptr) = str;
			++ output_ptr;
			input_ptr += ptr_movelen;
		}
		(*output_ptr) = '\0';
	}

	return true;
}



/** RKѴơ֥ν
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Wed,11 Sep,2013
 */
bool init_parser_rk(void)
{
	for (struct rk_map_tables_t* tbl = rk_map_tables; NULL != tbl->table_name; ++tbl) {
		const bool ret = parseline_rk_build_map(tbl);
		if (!ret) {
			return false;
		}
	}

	return true;
}



/** RKѴơ֥θ
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Wed,11 Sep,2013
 */
bool fin_parser_rk(void)
{
	for (struct rk_map_tables_t* tbl = rk_map_tables; NULL != tbl->table_name; ++tbl) {
		const bool ret = parseline_rk_clear_map(tbl);
		if (!ret) {
			return false;
		}
	}

	return true;
}

/* [ End of File ] */
